#
# Table structure for table 'class'
#

CREATE TABLE `class` (
  `cod_class` int(11) NOT NULL auto_increment,
  `cod_file` int(11) NOT NULL default '0',
  `cod_package` int(10) unsigned default NULL,
  `name` varchar(30) NOT NULL default '',
  `description` text,
  `extends` varchar(30) default NULL,
  `author` varchar(100) default NULL,
  `since` varchar(100) default NULL,
  `version` varchar(100) default NULL,
  `static` char(1) default 'F',
  `file_line` int(11) NOT NULL default '0',
  `revision` int(11) NOT NULL default '1',
  PRIMARY KEY  (`cod_class`),
  KEY `IDX_CLASS_FK01` (`cod_file`),
  KEY `IDX_CLASS_FK02` (`cod_package`),
  KEY `IDX_CLASS_IE01` (`name`),
  KEY `IDX_CLASS_IE02` (`extends`),
  KEY `IDX_CLASS_IE03` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'constant'
#

CREATE TABLE `constant` (
  `cod_constant` int(11) NOT NULL auto_increment,
  `cod_file` int(11) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `value` varchar(200) NOT NULL default '',
  `description` varchar(200) default NULL,
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_constant`),
  KEY `IDX_CONSTANT_FK01` (`cod_file`),
  KEY `IDX_CONSTANT_IE01` (`name`),
  KEY `IDX_CONSTANT_IE02` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'example'
#

CREATE TABLE `example` (
  `cod_example` int(11) NOT NULL auto_increment,
  `cod_function` int(11) NOT NULL default '0',
  `description` text NOT NULL,
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_example`),
  KEY `IDX_CONSTANT_FK01` (`cod_function`),
  KEY `IDX_CONSTANT_IE01` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'file'
#

CREATE TABLE `file` (
  `cod_file` int(11) NOT NULL auto_increment,
  `cod_file_type` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `path` varchar(255) NOT NULL default '',
  `complete_path` varchar(255) NOT NULL default '',
  `extension` varchar(20) NOT NULL default '',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_file`),
  UNIQUE KEY `IDX_FILE_UK01` (`complete_path`),
  KEY `IDX_FILE_FK01` (`cod_file_type`),
  KEY `IDX_FILE_IE01` (`name`),
  KEY `IDX_FILE_IE02` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'file_type'
#

CREATE TABLE `file_type` (
  `cod_file_type` int(11) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `extension` varchar(20) NOT NULL default '',
  `language` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`cod_file_type`),
  KEY `IDX_FILE_TYPE_IE01` (`name`),
  KEY `IDX_FILE_TYPE_IE02` (`extension`),
  KEY `IDX_FILE_TYPE_IE03` (`language`)
) TYPE=MyISAM;

INSERT INTO file_type VALUES("1","PHP Scripts","php","PHP");
INSERT INTO file_type VALUES("2","PHP Include Files","inc","PHP");

#
# Table structure for table 'function'
#

CREATE TABLE `function` (
  `cod_function` int(11) NOT NULL auto_increment,
  `cod_file` int(11) NOT NULL default '0',
  `cod_class` int(11) default NULL,
  `name` varchar(30) NOT NULL default '',
  `author` varchar(100) NOT NULL default '',
  `access` enum('public','private','protected') default 'public',
  `description` text NOT NULL,
  `since` varchar(100) default NULL,
  `version` varchar(100) default NULL,
  `return` varchar(200) default NULL,
  `return_type` varchar(50) NOT NULL default 'unknown',
  `deprecated` char(1) NOT NULL default 'F',
  `static` char(1) NOT NULL default 'F',
  `ref` char(1) NOT NULL default 'F',
  `file_line` int(11) NOT NULL default '0',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_function`),
  KEY `IDX_FUNCTION_FK01` (`cod_file`),
  KEY `IDX_FUNCTION_FK02` (`cod_class`),
  KEY `IDX_FUNCTION_IE01` (`name`),
  KEY `IDX_FUNCTION_IE02` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'note'
#

CREATE TABLE `note` (
  `cod_note` int(11) NOT NULL auto_increment,
  `cod_class` int(11) default NULL,
  `cod_function` int(11) default NULL,
  `description` text NOT NULL,
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_note`),
  KEY `IDX_NOTE_FK01` (`cod_class`),
  KEY `IDX_NOTE_FK02` (`cod_function`),
  KEY `IDX_NOTE_IE01` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'package'
#

CREATE TABLE `package` (
  `cod_package` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_package`),
  KEY `IDX_PACKAGE_IE01` (`name`),
  KEY `IDX_PACKAGE_IE02` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'param'
#

CREATE TABLE `param` (
  `cod_param` int(11) NOT NULL auto_increment,
  `cod_function` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `datatype` varchar(50) NOT NULL default '',
  `description` varchar(250) NOT NULL default '',
  `default_value` varchar(200) default NULL,
  `ref` char(1) NOT NULL default '',
  `param_order` smallint(5) unsigned NOT NULL default '0',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_param`),
  KEY `IDX_PARAM_FK01` (`cod_function`),
  KEY `IDX_PARAM_IE01` (`name`),
  KEY `IDX_PARAM_IE02` (`param_order`),
  KEY `IDX_PARAM_IE03` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'project'
#

CREATE TABLE `project` (
  `cod_project` int(11) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `brief_description` varchar(100) NOT NULL default '',
  `description` text,
  `server_path` varchar(200) NOT NULL default '',
  `developers` varchar(200) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `website` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`cod_project`),
  KEY `IDX_PROJECT_IE01` (`name`)
) TYPE=MyISAM;



#
# Table structure for table 'property'
#

CREATE TABLE `property` (
  `cod_property` int(11) NOT NULL auto_increment,
  `cod_class` int(11) NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `datatype` varchar(50) NOT NULL default '',
  `value` varchar(255) default NULL,
  `description` text NOT NULL,
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_property`),
  KEY `IDX_PROPERTY_FK01` (`cod_class`),
  KEY `IDX_PROPERTY_IE01` (`name`),
  KEY `IDX_PROPERTY_IE02` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'revision'
#

CREATE TABLE `revision` (
  `cod_revision` int(11) NOT NULL auto_increment,
  `cod_project` int(11) NOT NULL default '0',
  `date_revision` date NOT NULL default '0000-00-00',
  `number_revision` varchar(10) NOT NULL default '0.0.1',
  PRIMARY KEY  (`cod_revision`),
  KEY `IDX_REVISION_FK01` (`cod_project`),
  KEY `IDX_REVISION_IE01` (`number_revision`)
) TYPE=MyISAM;



#
# Table structure for table 'see'
#

CREATE TABLE `see` (
  `cod_see` int(11) NOT NULL auto_increment,
  `cod_function` int(11) NOT NULL default '0',
  `class_name` varchar(100) default NULL,
  `function_name` varchar(100) NOT NULL default '',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_see`),
  KEY `IDX_SEE_FK01` (`cod_function`),
  KEY `IDX_SEE_IE01` (`class_name`),
  KEY `IDX_SEE_IE02` (`function_name`),
  KEY `IDX_SEE_IE03` (`revision`)
) TYPE=MyISAM;



#
# Table structure for table 'uses'
#

CREATE TABLE `uses` (
  `cod_use` int(11) NOT NULL auto_increment,
  `cod_class` int(11) NOT NULL default '0',
  `name_class_used` varchar(100) NOT NULL default '',
  `revision` int(11) NOT NULL default '0',
  PRIMARY KEY  (`cod_use`),
  KEY `IDX_USES_FK01` (`cod_class`),
  KEY `IDX_USES_IE01` (`name_class_used`),
  KEY `IDX_USES_IE02` (`revision`)
) TYPE=MyISAM;

